require 'fluent/plugin/output'
require 'event_services_pb'

module Fluent::Plugin
  class GrpcOutput < Output

    Fluent::Plugin.register_output('grpc', self)

    desc 'The endpoint of gRPC server.'
    config_param :path, :string

    def start
      super
      @stub = Event::Forwarder::Stub.new(@path, :this_channel_is_insecure)
    end

    def write(chunk)
      chunk.each do |time, record|
        ack = @stub.forward(Event::Log.new(name: record['message']))
        $stdout.puts ack.type
      end
    end

  end
end
